=== etc/r/requirements.txt ===
lintr
microbenchmark
jsonlite
VGAM
distr
