=== tools/lint/r/DESCRIPTION ===
Package: rlint
Title: Lint R Code
Version: 0.0.0
Authors@R: person("stdlib", "js", role = c("aut","cre"))
Description: Lints R code.
Depends: R (>=3.4.0)
Imports:
	lintr
LazyData: true
