=== base/arcsine/benchmark/r/DESCRIPTION ===
Package: rarcsine-benchmarks
Title: Benchmarks
Version: 0.0.0
Authors@R: person("stdlib", "js", role = c("aut","cre"))
Description: Benchmarks.
Depends: R (>=3.4.0)
Imports:
	microbenchmark
	distr
LazyData: true
