=== base/bernoulli/benchmark/r/DESCRIPTION ===
Package: rbinom-benchmarks
Title: Benchmarks
Version: 0.0.0
Authors@R: person("stdlib", "js", role = c("aut","cre"))
Description: Benchmarks.
Depends: R (>=3.4.0)
Imports:
	microbenchmark
LazyData: true
