=== debian/changelog ===
node-stdlib (0.0.96+ds1+~cs0.0.429-2) unstable; urgency=medium

  * Source-only upload

 -- Yadd <yadd@debian.org>  Thu, 19 Oct 2023 11:54:09 +0400

node-stdlib (0.0.96+ds1+~cs0.0.429-1) unstable; urgency=medium

  * Initial release (Closes: #1052301)

 -- Yadd <yadd@debian.org>  Wed, 20 Sep 2023 09:44:33 +0400
