=== debian/control ===
Source: node-stdlib
Section: javascript
Priority: optional
Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
Uploaders: Yadd <yadd@debian.org>
Testsuite: autopkgtest-pkg-nodejs
Build-Depends:
 debhelper-compat (= 13)
 , dh-sequence-nodejs
 , dh-nodejs
 , node-acorn <!nocheck>
 , node-d3-format <!nocheck>
 , node-d3-scale <!nocheck>
 , node-d3-shape <!nocheck>
 , node-d3-time-format <!nocheck>
 , node-debug <!nocheck>
 , node-glob <!nocheck>
 , node-gyp <!nocheck>
 , node-minimist <!nocheck>
 , node-readable-stream <!nocheck>
 , node-resolve <!nocheck>
 , node-vdom-to-html <!nocheck>
Standards-Version: 4.6.2
Homepage: https://stdlib.io
Vcs-Git: https://salsa.debian.org/js-team/node-stdlib-stats.git
Vcs-Browser: https://salsa.debian.org/js-team/node-stdlib-stats
Rules-Requires-Root: no

Package: node-stdlib
Architecture: all
Depends: ${misc:Depends}
 , node-acorn
 , node-d3-format
 , node-d3-scale
 , node-d3-shape
 , node-d3-time-format
 , node-debug
 , node-glob
 , node-gyp
 , node-minimist
 , node-readable-stream
 , node-resolve
 , node-vdom-to-html
Provides: ${nodejs:Provides}
Description: Standard library for JavaScript and Node.js
 node-stdlib is a standard library for JavaScript and Node.js, with an
 emphasis on numerical and scientific computing applications. The library
 provides a collection of robust, high performance libraries for mathematics,
 statistics, data processing, streams, and more and includes many utilities
 expected from a standard library.
