=== debian/watch ===
version=4

opts=\
dversionmangle=auto,\
repacksuffix=+ds1,\
filenamemangle=s/.+\/v?(\d\S+)@ARCHIVE_EXT@/@PACKAGE@-$1\.tar\.gz/ \
 https://github.com/stdlib-js/stdlib/tags .*/v?(\d\S+)\.tar\.gz group

opts=\
component=stdlib-stats,\
dversionmangle=auto,\
filenamemangle=s/.+\/v?(\d\S+)@ARCHIVE_EXT@/node-stdlib-stats-$1\.tar\.gz/ \
 https://github.com/stdlib-js/stats/tags .*/v?(\d\S+)\.tar\.gz checksum

opts=\
component=stdlib-array,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-stdlib-array-$1/ \
 https://github.com/stdlib-js/array/tags .*/archive.*/v?([\d\.]+).tar.gz checksum

opts=\
component=stdlib-assert,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-stdlib-assert-$1/ \
 https://github.com/stdlib-js/assert/tags .*/archive.*/v?([\d\.]+).tar.gz checksum

opts=\
component=stdlib-boolean,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-stdlib-boolean-$1/ \
 https://github.com/stdlib-js/boolean/tags .*/archive.*/v?([\d\.]+).tar.gz checksum

opts=\
component=stdlib-utils,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-stdlib-utils-$1/ \
 https://github.com/stdlib-js/utils/tags .*/archive.*/v?([\d\.]+).tar.gz checksum

opts=\
component=stdlib-blas,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-stdlib-blas-$1/ \
 https://github.com/stdlib-js/blas/tags .*/archive.*/v?([\d\.]+).tar.gz checksum

opts=\
component=stdlib-math,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-stdlib-math-$1/ \
 https://github.com/stdlib-js/math/tags .*/archive.*/v?([\d\.]+).tar.gz checksum

opts=\
component=stdlib-complex,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-stdlib-complex-$1/ \
 https://github.com/stdlib-js/complex/tags .*/archive.*/v?([\d\.]+).tar.gz checksum

opts=\
component=stdlib-number,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-stdlib-number-$1/ \
 https://github.com/stdlib-js/number/tags .*/archive.*/v?([\d\.]+).tar.gz checksum

opts=\
component=stdlib-constants,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-stdlib-constants-$1/ \
 https://github.com/stdlib-js/constants/tags .*/archive.*/v?([\d\.]+).tar.gz checksum

opts=\
component=stdlib-os,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-stdlib-os-$1/ \
 https://github.com/stdlib-js/os/tags .*/archive.*/v?([\d\.]+).tar.gz checksum

opts=\
component=stdlib-cli,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-stdlib-cli-$1/ \
 https://github.com/stdlib-js/cli/tags .*/archive.*/v?([\d\.]+).tar.gz checksum

opts=\
component=stdlib-string,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-stdlib-string-$1/ \
